Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.awt.image
Class LookupOp

    java.lang.Object
      |
      +--java.awt.image.LookupOp

All Implemented Interfaces:
  BufferedImageOp, RasterOp

public class LookupOp
extends Object
implements BufferedImageOp, RasterOp

This class implements a lookup operation from the source to the destination. The LookupTable object may contain a single array or multiple arrays, subject to the restrictions below.

For Rasters, the lookup operates on bands. The number of lookup arrays may be one, in which case the same array is applied to all bands, or it must equal the number of Source Raster bands.

For BufferedImages, the lookup operates on color and alpha components. The number of lookup arrays may be one, in which case the same array is applied to all color (but not alpha) components. Otherwise, the number of lookup arrays may equal the number of Source color components, in which case no lookup of the alpha component (if present) is performed. If neither of these cases apply, the number of lookup arrays must equal the number of Source color components plus alpha components, in which case lookup is performed for all color and alpha components. This allows non-uniform rescaling of multi-band BufferedImages.

BufferedImage sources with premultiplied alpha data are treated in the same manner as non-premultiplied images for purposes of the lookup. That is, the lookup is done per band on the raw data of the BufferedImage source without regard to whether the data is premultiplied. If a color conversion is required to the destination ColorModel, the premultiplied state of both source and destination will be taken into account for this step.

Images with an IndexColorModel cannot be used.

If a RenderingHints object is specified in the constructor, the color rendering hint and the dithering hint may be used when color conversion is required.

This class allows the Source to be the same as the Destination.

See Also:
  `LookupTable`, `RenderingHints.KEY_COLOR_RENDERING`, `RenderingHints.KEY_DITHERING`

Constructor Summary
`LookupOp(LookupTable lookup, RenderingHints hints)` Constructs a LookupOp object given the lookup table and a RenderingHints object (which may be null).

Method Summary
`BufferedImage` | `createCompatibleDestImage(BufferedImage src, ColorModel destCM)` Creates a zeroed destination image with the correct size and number of bands.
`WritableRaster` | `createCompatibleDestRaster(Raster src)` Creates a zeroed destination Raster with the correct size and number of bands, given this source.
`BufferedImage` | `filter(BufferedImage src, BufferedImage dst)` Performs a lookup operation on a BufferedImage.
`WritableRaster` | `filter(Raster src, WritableRaster dst)` Performs a lookup operation on a Raster.
`Rectangle2D` | `getBounds2D(BufferedImage src)` Returns the bounding box of the filtered destination image.
`Rectangle2D` | `getBounds2D(Raster src)` Returns the bounding box of the filtered destination Raster.
`Point2D` | `getPoint2D(Point2D srcPt, Point2D dstPt)` Returns the location of the destination point given a point in the source.
`RenderingHints` | `getRenderingHints()` Returns the rendering hints for this op.
`LookupTable` | `getTable()` Returns the LookupTable.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### LookupOp

    public LookupOp(LookupTable lookup,
                    RenderingHints hints)

  Constructs a LookupOp object given the lookup table and a RenderingHints object (which may be null).

Method Detail

### getTable

    public final LookupTable getTable()

  Returns the LookupTable.

### filter

    public final BufferedImage filter(BufferedImage src,
                                      BufferedImage dst)

  Performs a lookup operation on a BufferedImage. If the color model in the source image is not the same as that in the destination image, the pixels will be converted in the destination. If the destination image is null, a BufferedImage will be created with an appropriate ColorModel. An IllegalArgumentException may be thrown if the number of arrays in the LookupTable does not meet the restrictions stated in the class comment above, or if the source image has an IndexColorModel.
  Specified by:
    `filter` in interface `BufferedImageOp`

### filter

    public final WritableRaster filter(Raster src,
                                       WritableRaster dst)

  Performs a lookup operation on a Raster. If the destination Raster is null, a new Raster will be created. The IllegalArgumentException may be thrown if the source and destination Rasters have different numbers of bands or if the number of arrays in the LookupTable does not meet the restrictions stated in the class comment above.
  Specified by:
    `filter` in interface `RasterOp`

### getBounds2D

    public final Rectangle2D getBounds2D(BufferedImage src)

  Returns the bounding box of the filtered destination image. Since this is not a geometric operation, the bounding box does not change.
  Specified by:
    `getBounds2D` in interface `BufferedImageOp`

### getBounds2D

    public final Rectangle2D getBounds2D(Raster src)

  Returns the bounding box of the filtered destination Raster. Since this is not a geometric operation, the bounding box does not change.
  Specified by:
    `getBounds2D` in interface `RasterOp`

### createCompatibleDestImage

    public BufferedImage createCompatibleDestImage(BufferedImage src,
                                                   ColorModel destCM)

  Creates a zeroed destination image with the correct size and number of bands. If destCM is null, an appropriate ColorModel will be used.
  Specified by:
    `createCompatibleDestImage` in interface `BufferedImageOp`
  Parameters:
    `src` - Source image for the filter operation.
    `destCM` - ColorModel of the destination. Can be null.

### createCompatibleDestRaster

    public WritableRaster createCompatibleDestRaster(Raster src)

  Creates a zeroed destination Raster with the correct size and number of bands, given this source.
  Specified by:
    `createCompatibleDestRaster` in interface `RasterOp`

### getPoint2D

    public final Point2D getPoint2D(Point2D srcPt,
                                    Point2D dstPt)

  Returns the location of the destination point given a point in the source. If dstPt is non-null, it will be used to hold the return value. Since this is not a geometric operation, the srcPt will equal the dstPt.
  Specified by:
    `getPoint2D` in interface `BufferedImageOp`

### getRenderingHints

    public final RenderingHints getRenderingHints()

  Returns the rendering hints for this op.
  Specified by:
    `getRenderingHints` in interface `BufferedImageOp`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.